//+------------------------------------------------------------------+
//|                                                           EA.mq4 |
//|                                        MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <mtp_core\eafunctions.mqh>
//#include <mtp_core\moneymanagement.mqh>

#include <mtp_modules\eascript\variables.mqh>
#include <mtp_modules\orderscripts\variables.mqh>

extern double lotsize = 0.1;

//#include <mtp_modules\moneymanagement\parameters.mqh>

extern double _slippage_open = 3;
extern double _slippage_close = 5;
extern double stoploss = 28;
extern double takeprofit = 200;


extern double breakevenat = 25;
extern double trailingstop_activate = 25;
extern double trailingstop = 25;
extern double trailingstop_step = 1;


/*
extern int starthour = 0;
extern int startminute = 0;
extern int endhour = 24;
extern int endminute = 0;
*/

//extern bool signal_enabled;
extern int bar = 1;
extern int timeframe = 0;

extern string i1_name = "smC4Scalper_Candles_v3.1";
extern int i1_num_params = 7;
extern double i1_param1 = 3;
extern double i1_param2 = 1;
extern double i1_param3 = 1;
extern double i1_param4 = 1;
extern double i1_param5 = 0;
extern double i1_param6 = 167;
extern double i1_param7 = 500;
extern double i1_param8 = 0;


extern string i2_name = "";
extern int i2_num_params = 0;
extern double i2_param1 = 0;
extern double i2_param2 = 0;
extern double i2_param3 = 0;
extern double i2_param4 = 0;
extern double i2_param5 = 0;
extern double i2_param6 = 0;
extern double i2_param7 = 0;
extern double i2_param8 = 0;


extern int mode = 1;
extern string mode1_description = "simple arrow indicator, you need to give the buy and sell indicator index";
extern int mode1_buy_ind = 1;
extern int mode1_buy_idx = 3;
extern int mode1_sell_ind = 1;
extern int mode1_sell_idx = 2;

extern string mode2_description = "any condition between indicator or level";
extern string mode2_setting1 = "condition is between \'right\' and \'left\' indicator or value, if \'ind\' is 0, the \'val\' is used";
extern string mode2_condition_desc = "possible conditions: \'!=\',\'==\',\'>\',\'>=\',\'<\',\'<=\'";

extern int mode2_buy_left_ind = 2;
extern int mode2_buy_left_idx = 0;
extern double mode2_buy_left_val = 0;

extern int mode2_buy_right_ind = 1;
extern int mode2_buy_right_idx = 0;
extern double mode2_buy_right_val = 0;

extern string mode2_buy_condition = ">";

extern int mode2_sell_left_ind = 1;
extern int mode2_sell_left_idx = 0;
extern double mode2_sell_left_val = 0;

extern int mode2_sell_right_ind = 1;
extern int mode2_sell_right_idx = 0;
extern double mode2_sell_right_val = 0;

extern string mode2_sell_condition = "<";

extern bool mode2_onlycross = false;

bool debug = false;

extern bool long_enabled = true;
extern bool short_enabled = true;
extern bool reverse_strategy = false;
extern bool oneperbar = true;
extern bool trade_only_signal_change = true;
extern bool trade_only_firsttick = true;
extern bool trade_on_start = false;
extern bool enableclose = true;
extern bool openafterclose = true;
extern int maxorders = 1;

extern bool _orderbymarket = true;

extern int _stealth_sl = 2;
extern int _stealth_tp = 2;
extern int _stealth_pending = 2;

extern int _magic = 1234;
extern int _sleepok = 500;
extern int _sleeperr = 1000;

extern bool printcomment = false;

#include <mtp_modules\eascript\functions.mqh>
#include <mtp_modules\orderscripts\functions.mqh>
//#include <mtp_modules\moneymanagement\functions.mqh>

int init()
{
   variables_init();
   variables_priceinit();
   if (isfractional())
   {
      fractd(_slippage_open);
      fractd(_slippage_close);
      fractd(stoploss);
      fractd(takeprofit);
      
      fractd(breakevenat);
      fractd(trailingstop_activate);
      fractd(trailingstop);
      fractd(trailingstop_step);
      
   }
   
   slippage_open = _slippage_open;
   slippage_close = _slippage_close;
   orderbymarket = _orderbymarket;
   magic = _magic;
   sleepok = _sleepok;
   sleeperr = _sleeperr;

   stealth_sl = _stealth_sl;
   stealth_tp = _stealth_tp;
   stealth_pending = _stealth_pending;
   
   #include <mtp_modules\orderscripts\init.mqh>

   return(0);
}

int deinit()
{
   return(0);
}

void check_action(string action)
{
  #include <mtp_modules\orderscripts\actions.mqh>
}

double getind(int bar, int ind, int idx, int num_params, double param1, double param2, double param3, double param4, double param5, double param6, double param7, double param8)
{
   double val = 0;
   string indicator_name;
   if (ind == 1) indicator_name = i1_name;
   else if (ind == 2) indicator_name = i2_name;
   else {
      Alert("Wrong indicator number");
   }
   if (num_params == 0) val = iCustom(symbol,timeframe,indicator_name,idx,bar);
   if (num_params == 1) val = iCustom(symbol,timeframe,indicator_name,param1,idx,bar);
   if (num_params == 2) val = iCustom(symbol,timeframe,indicator_name,param1,param2,idx,bar);
   if (num_params == 3) val = iCustom(symbol,timeframe,indicator_name,param1,param2,param3,idx,bar);
   if (num_params == 4) val = iCustom(symbol,timeframe,indicator_name,param1,param2,param3,param4,idx,bar);
   if (num_params == 5) val = iCustom(symbol,timeframe,indicator_name,param1,param2,param3,param4,param5,idx,bar);
   if (num_params == 6) val = iCustom(symbol,timeframe,indicator_name,param1,param2,param3,param4,param5,param6,idx,bar);
   if (num_params == 7) val = iCustom(symbol,timeframe,indicator_name,param1,param2,param3,param4,param5,param6,param7,idx,bar);
   if (num_params == 8) val = iCustom(symbol,timeframe,indicator_name,param1,param2,param3,param4,param5,param6,param7,param8,idx,bar);
   if (debug) addcomment("indicator ",indicator_name," value:",val,"\n");
   return(val);
}

double getval(int bar, int ind, int idx, double val)
{
   double ret = 0;
   if (ind == 0) ret = val;
   else if (ind == 1) ret = getind(bar,ind,idx,i1_num_params,i1_param1,i1_param2,i1_param3,i1_param4,i1_param5,i1_param6,i1_param7,i1_param8);
   else if (ind == 2) ret = getind(bar,ind,idx,i2_num_params,i2_param1,i2_param2,i2_param3,i2_param4,i2_param5,i2_param6,i2_param7,i2_param8);
   else {
      Alert("Wrong indicator number. Parameters containing \'ind\' should be 1 or 2");
      return(0);
   }
   if (debug) addcomment("value:",ret,"\n");
   return(ret);
}

int anycondition(int signal, int left_ind, int left_idx, double left_val, int right_ind, int right_idx, double right_val, string condition, bool onlycross, int id)
{
   int returnsignal = SIGNAL_NO;
   double val_left = getval(bar, left_ind, left_idx, left_val);
   double val_right = getval(bar, right_ind, right_idx, right_val);
   if (condition == "==") {
      if (q(val_left,val_right)) returnsignal = signal;      
   } else if (condition == "!=") {
      if (!q(val_left,val_right)) returnsignal = signal;
   } else if (condition == ">=") {
      if (lq(val_left,val_right)) returnsignal = signal;
   } else if (condition == "<=") {
      if (sq(val_left,val_right)) returnsignal = signal;
   } else if (condition == ">") {
      if (l(val_left,val_right)) returnsignal = signal;
   } else if (condition == "<") {
      if (s(val_left,val_right)) returnsignal = signal;
   } else {
      Alert("invalid condition: ",condition);
   }
   if (debug) addcomment("signal id ",id," : ",returnsignal,"\n");
   //if (returnsignal == signal) {
      if (onlycross) {
         if (bar >= 1) {
            double val_left_last = getval(bar+1,left_ind,left_idx,left_val);
            double val_right_last = getval(bar+1,right_ind,right_idx,right_val);
         } else {
            static bool start[10] = {true,true,true,true,true,true,true,true,true,true};
            static double lastval_right[10];
            static double lastval_left[10];
            if (start[id]) {
               lastval_right[id] = val_left;
               lastval_left[id] = val_right;
               start[id] = false;
            }
            val_left_last = lastval_left[id];
            val_right_last = lastval_right[id];
            lastval_left[id] = val_left;
            lastval_right[id] = val_right;
         }
         if (condition == "==") {
            if (q(val_left_last,val_right_last)) returnsignal = SIGNAL_NO;      
         } else if (condition == "!=") {
            if (!q(val_left_last,val_right_last)) returnsignal = SIGNAL_NO;
         } else if (condition == ">=") {
            if (lq(val_left_last,val_right_last)) returnsignal = SIGNAL_NO;
         } else if (condition == "<=") {
            if (sq(val_left_last,val_right_last)) returnsignal = SIGNAL_NO;
         } else if (condition == ">") {
            if (l(val_left_last,val_right_last)) {
               returnsignal = SIGNAL_NO;
            }
         } else if (condition == "<") {
            if (s(val_left_last,val_right_last)) {
               returnsignal = SIGNAL_NO;
            }
         } else {
            Alert("invalid condition: ",condition);
         }
         if (debug) addcomment("signal onlycross ",id," : ",returnsignal,"\n");
      }      
   //}   
   return(returnsignal);
}

int signal_mode2()
{
   int signal = SIGNAL_NO;
   int signal_buy = SIGNAL_NO;
   int signal_sell = SIGNAL_NO;
   signal_buy = anycondition(SIGNAL_BUY, mode2_buy_left_ind, mode2_buy_left_idx, mode2_buy_left_val, mode2_buy_right_ind, mode2_buy_right_idx, mode2_buy_right_val, mode2_buy_condition, mode2_onlycross, 0);
   signal_sell = anycondition(SIGNAL_SELL, mode2_sell_left_ind, mode2_sell_left_idx, mode2_sell_left_val, mode2_sell_right_ind, mode2_sell_right_idx, mode2_sell_right_val, mode2_sell_condition, mode2_onlycross, 1);
   if (debug) addcomment("signal buy: ",signal_buy," signal_sell:",signal_sell,"\n");   
   signal = signaladd_or(signal_buy,signal_sell);
   if (signal == SIGNAL_BOTH) signal = SIGNAL_NO;
   addcomment("mode2 signal: ",signaltext(signal),"\n");
   return(signal);
}

int signal_mode1()
{
   double buy = getval(bar, mode1_buy_ind, mode1_buy_idx, 0);
   double sell = getval(bar, mode1_sell_ind, mode1_sell_idx, 0);
   int signal = signal_arrow(buy,sell);
   addcomment("mode1 signal: ",signaltext(signal),"\n");
   return(signal);
}

int signal()
{
   int signal = -1;
   if (mode == 1) signal = signal_mode1();
   else if (mode == 2) signal = signal_mode2();
   else {
      Alert("invalid mode: ",mode);
   }
   return(signal);
}


int closesignal()
{
   int signal = SIGNAL_NO;
   //if (closesignal_color_enabled) signal = signaladd_or(signal,signal_samplecolor());
   return(signal);
}

int start()
{

   addcomment("www.metatraderprogrammer.com\n");

   /*if (realalert("Run this software on demo account only!\n"))
   {
      return(0);
   }*/

   realalert();

   variables_priceinit();
   
   isfirsttick(timeframe);

   #include <mtp_modules\eascript\tasks.mqh>

   bool enableopen = true;
   
   int signal = signal();
   int closesignal = closesignal();

   /*if (isexpired(1000,01,01))
   {
      signal = 0;
      enableopen = false;
   }*/
   
   /*if (!istradinghours(starthour,endhour,startminute,endminute))
   {
      enableopen = false;
      addcomment("out of trading hours\n");
   }*/
   
   signalhandler (
   signal,
   closesignal,
   enableopen,
   trade_only_firsttick,
   trade_only_signal_change,
   oneperbar,
   trade_on_start,
   timeframe,
   /*comments*/ true,
   reverse_strategy,
   1);

   if (signal != 0)
   {
      int cnt;
      if (signal == SIGNAL_BUY)
      {
         if (!openafterclose) cnt = cnt_orders(ORDERSELECT_ANY);
         if (enableclose) close_all(ORDERSELECT_SHORT);
         if (openafterclose) cnt = cnt_orders(ORDERSELECT_ANY);
         if (enableopen && cnt < maxorders && long_enabled) open_market(OP_BUY);
      }
      if (signal == SIGNAL_SELL)
      {
         if (!openafterclose) cnt = cnt_orders(ORDERSELECT_ANY);
         if (enableclose) close_all(ORDERSELECT_LONG);
         if (openafterclose) cnt = cnt_orders(ORDERSELECT_ANY);
         if (enableopen && cnt < maxorders && short_enabled) open_market(OP_SELL);
      }
   }

   if (closesignal == SIGNAL_BUY)
   {
      close_all(ORDERSELECT_SHORT);
   }
   if (closesignal == SIGNAL_SELL)
   {
      close_all(ORDERSELECT_LONG);
   }
   if (closesignal == SIGNAL_BOTH)
   {
      close_all(ORDERSELECT_ANY);
   }

   
   trailingstop(breakevenat,trailingstop,trailingstop_activate,trailingstop_step);
   
   
   stealth_run();
   stealthpending_run();
   
   writecomment();
   if (printcomment) printcomment();
   delcomment();

   return(0);
}

void beforeorder(int cmd)
{
   //#include <mtp_modules\moneymanagement\beforeorder.mqh>
}

void afterorder(int cmd, int ticket)
{

}

void open_market(int cmd)
{
   beforeorder(cmd);
   int ticket = marketorder(cmd,lotsize,stoploss,takeprofit);
   afterorder(cmd, ticket);
}

void open_pending(int cmd)
{
   Alert("not allowed");
}

